//--------------------------------
// Routines lecture encodeurs 
// pour le programme OneBitSynth
//--------------------------------

//-----------------------------------------
// Initialise les parametres necessaire
// pour execution d'une ISR par le timer 2
// toutes les 2ms, afin de lire la position
// des 4 encodeurs rotatifs
//-----------------------------------------
void encodeursSetup(void) {
byte i;
	//-------------------------------------
	// Initialisation des pin des encodeurs
	// Mode input
	// Resistance pull-up activee
	//-------------------------------------
	for(i=0;i<2;i++) {
		pinMode(pinA[i], INPUT);
		pinMode(pinB[i], INPUT);
		digitalWrite(pinA[i],HIGH);
		digitalWrite(pinB[i],HIGH);
	}

}

//-------------------------------------------
// Lit les boutons et renvoie la valeurs lues
// Ne permet qu'une saisie quand un bouton
// est appuyé
//-------------------------------------------
byte readButtons() {
int c = 0;
	c=analogRead(A0);      // Lit lentree analogique 
	
   if (c>950) {
       lastBoutonNav=0;  // Remettre flag etat a zero
       return 0;           // Pas de bouton appuyé sortir
   }

  if (lastBoutonNav>0)   // Si le dernier bouton n'a pas ete relache
      return 9;
  // Arrivé ici on est sur que le bouton a ete appuye

  if (c>150 && c<350) {
      lastBoutonNav=1;
      return 1;           // bouton menu
  } 
  if (c>400 && c<600) {
      lastBoutonNav=2;
      return 2;           // bouton presets
  }                       
  return 0;
}

//--------------------------------------------
// Routine principale de lecture des encodeurs
//--------------------------------------------
byte readEncodeurs(void) {
byte i,val;
  val=0;
  // Lire les 2 encodeurs
  for (i=0;i<2;i++) {
    // si la valeur a variee pour un des encodeurs
    if (lcounter[i]!=bcounter[i]) {
      // Tester le send
      // Si UP valeur de 11 a 12
      if (bcounter[i]>lcounter[i])
        val=i+11;
      // Si down valeur de 1 a 2
      else
        val=i+1;
      lcounter[i]=bcounter[i];
      return val;
    }
  }
  return 0;		// retourne 0 si aucun encodeur a bouge
}

//--------------------------------------------------
// Routine scannin encodeurs
// Compare la derniere sequence lue a celle en cours
//--------------------------------------------------
void scan_encodeurs(void) {
int MSB;			// MSB encodeur
int LSB;			// LSB encodeur
int encoded;		// Etat sur 4 bits encodeurs
int sum;			// sum comparaison encodeurs

	// Toggle for encoder reading
	if (nencRead)
		nencRead=0;
	else
		nencRead=1;

	MSB = bitRead(PIND,pinA[nencRead]); // MSB = most significant bit
	LSB = bitRead(PIND,pinB[nencRead]); // LSB = least significant bit
	encoded = (MSB << 1) |LSB; // conversion
	// Le test suivant permet juste d'accelerer l'ISR
	// si aucun encodeur n'a ete manoeuvre
	if (encoded==lastEncoded[nencRead]) 
		return;
	sum  = (lastEncoded[nencRead] << 2) | encoded; // Ajout a la valeur precedent
		
	switch(sum) {
		// Patterns pour encodeurs vers la droite
		case 0b1101:
		case 0b0100:
		case 0b0010:
		case 0b1011:
			counter[nencRead]++;
			break;
		// Patterns pour encodeurs vers la gauche
		case 0b1110:
		case 0b0111:
		case 0b0001:
		case 0b1000:
			counter[nencRead]--;
			break;
	}
	lastEncoded[nencRead] = encoded;   // On memorise la valeur pour la prochaine fois
	bcounter[nencRead]=counter[nencRead]>>1;  // Compteur utilisateur divise par 2
}

