//----------------------------------------
// Routines lecture MIDI par interruption
// pour le programme OneBitSynth
//----------------------------------------

                   
//----------------------------				   
// Lecture des entrees CV/GATE
// pour VCA et pitch
//----------------------------				   
void ReadCvGate(void)  {
int AnalogIn;
	if (usemidi!=2)			// Mode CV/GATE uniquement si usemidi==2
		return;
	// Lecture de la PIN 2 pour déclenchement GATE
	if (PIND & 0x04) 
		noteon=1;
	else
		noteon=0;
	AnalogIn=analogRead(A1);
	pitch=4200-AnalogIn*4;
	AnalogIn=analogRead(A2);
	if (AnalogIn)
		lfofreq=AnalogIn/4;
	else
		lfofreq=0;
	RaffParamLcd[2]=1;
/*		
		if (!noteon) {
			noteon=1;
		}
	}
	else {
		if (noteon)
			noteon=0;
	}
	
	*/
}

//-----------------------------------------
// Handler CC MIDI
// Gere la selection de forme d'onde
// Le slide, le decay, l'accent
// le cutoff et l'envmod
//----------------------------------------
void MyHandleCtrlCV(byte channel, byte number, byte value) {
	if (usemidi!=1)
		return;
	switch(number) {
		case CTRLLFOWAVE :
			RaffParamLcd[1]=1;
			lfowavenum=value/16;
			break;
			
		case CTRLLFOFREQ :
			RaffParamLcd[2]=1;
			if (!value) {
				lfofreq=0;
				break;
			}
			if (value<20) {
				lfofreq=value;
				break;
			}
			lfofreq=value*2;
			break;
		case CTRLLFODEPTH :
			RaffParamLcd[3]=1;
			if (!value) {
				lfodepth=0;
				break;
			}
			if (value<20) {
				lfodepth=value;
				break;
			}
			lfodepth=value*2;
			break;
		default:
			break;
	}
}


//----------------------
// HANDLER NOTE OFF MIDI
//---------------------- 
void  MyHandleNoteOffCV(byte channel, byte mynote, byte velocity) {
	if (usemidi!=1)
		return;
	noteon = 0;
	// midilastnote = 0xFF;
	if (CountNote) 			// Si countnote >0
		CountNote--;		// decrementer jusqu'a 0 si besoin
}
                                                                                             
//--------------------- 
// HANDLER NOTE ON MIDI
//--------------------- 
void MyHandleNoteOnCV(byte channel, byte mynote, byte velocity) {
	if (usemidi!=1)
		return;
	// Si velocity == 0 alors on a recu un note off
	//---------------------------------------------
	if (velocity==0) {
		MyHandleNoteOffCV(channel,mynote,velocity);
		return;
	}
	noteon = 1;
	// recalcul de la frequence
	pitch = pgm_read_word(freqvals+mynote);
}
